<?
 class blog_setup extends BasePluginSetup
 {
  function init()
  {
   global $_path;

   $this->modules();

   //copy css
   $this->mkdir($_path["project"]["style"]);
   $this->file("setup/blog.css", $_path["project"]["style"]);

   return true;
  }

  function postSetup()
  {
   $BLOGID="BLOG CONTAINER";
   $COMMENTID="BLOG COMMENTS CONTAINER";

   //get root category
   $d=Data::cache("categories", "tree", "down");
   $d->setShowFields("nr");

   $d->setValue("catnr", 0);
   $d->setValue("treedepth", 0);

   if(!$d->get()||!$d->next())
   {
    $this->e->add("Root category not found");
    $this->e->add($d->e);
    return false;
   }

   $rootcatnr=$d->v["nr"];

   //get blog category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $rootcatnr);
   $d->setValue("text", $BLOGID);

   if(!$d->get()||!$d->next()) //no blog category found
   {
    //add new blog category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $rootcatnr);
    $d->setValue("name", "Blog");
    $d->setValue("text", $BLOGID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("blog_entries", "blog_tags"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("Blog category added", "note");

    $blogcatnr=$d->getValue("nr");
   }
   else //blog category found
   {
    //update if necessary
    $blogcatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("blog_entries", $d->v["module"])||
     !in_array("blog_tags", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $blogcatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("blog_entries", "blog_tags"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("Blog category updated", "note");
    }
   }

   //get blog comments category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();
   $d->e->clear();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $blogcatnr);
   $d->setValue("text", $COMMENTID);

   if(!$d->get()||!$d->next()) //no blog category found
   {
    //add new blog category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $blogcatnr);
    $d->setValue("name", "Comments");
    $d->setValue("text", $COMMENTID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("blog_comments"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("Blog comments category added", "note");

    $commentscatnr=$d->getValue("nr");
   }
   else //blog category found
   {
    //update if necessary
    $commentscatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("blog_comments", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $commentscatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("blog_comments"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("Blog comments category updated", "note");
    }
   }


   return true;
  }

 }
?>
